# Bonus: create an interactive 3d view of hcl colour space. 

library(rgl)

jitter2 <- function(x) {
  res <- min(diff(sort(unique(x)))) / 2
  x + runif(length(x), min = -res, max = res)
}

cols <- expand.grid(
  x = seq(-1, 1, length = 25), 
  y = seq(-1, 1, length = 25),
  l = seq(5, 95, length = 25)
)
cols <- within(cols, {
  x <- jitter2(x)
  y <- jitter2(y)
  l <- jitter2(l)
  
  r <- sqrt(x^2 + y^2)
  
  c <- 100 * r
  h <- 180 / pi * atan2(x, y)
})

cols <- subset(cols, r <= 1)

cols$colour <- with(cols, hcl(h, c, l, fixup = FALSE))
valid <- subset(cols, !is.na(colour))

r3dDefaults$bg$color <- "grey50"
clear3d(defaults = r3dDefaults)
par3d(FOV=1)
with(valid, plot3d(x, y, l, col = colour, size = 8, 
  axes = F))
  

# library(dichromat)
# valid$dcolour <- dichromat(valid$colour)
# with(valid, plot3d(x, y, l, col = dcolour, size = 8, 
#   axes = F))
