library(ggplot2)
troops <- read.table("minard-troops.txt", header = T)
cities <- read.table("minard-cities.txt", header = T)

ggplot(cities, aes(long, lat)) + 
  geom_path(aes(size = survivors, colour = direction, 
    group = interaction(group, direction)), data = troops) + 
  geom_text(aes(label = city), hjust = 0, vjust = 1, size = 4)

# Polish appearance
last_plot() + 
  scale_x_continuous("", limits = c(24, 39)) + 
  scale_y_continuous("") + 
  scale_colour_manual(values = c("grey50","red")) +
  scale_size(to = c(1, 10))
